local nn =require("nn")
local shd = require("shaders")

local ScrW, ScrH = love.graphics.getWidth, love.graphics.getHeight
local physics = love.physics

local color = love.graphics.setColor
local circ = love.graphics.circle
local line = love.graphics.line

local isMDown,isDown = love.mouse.isDown,love.keyboard.isDown

local m1d = false
local m2d = false

local dpx, dpy = 0,0
local drx, dry = 0,0

local sin,cos,atan2,pi = math.sin,math.cos,math.atan2,math.pi
local pi2 = pi/2
local flr = math.floor

math.randomseed(os.time())

local _fill,_line = "fill","line"

function rot(x,y,r)
	return x*cos(r*pi/180),y*sin(r*pi/180)
end

function hsv( h, s, v, a )	--https://github.com/EmmanuelOga/columns/blob/master/utils/color.lua (LICENSE: http://creativecommons.org/licenses/by/3.0/legalcode)
	h=h/360

	local i = flr(h * 6);
	local f = h * 6 - i;
	local p = v * (1 - s);
	local q = v * (1 - f * s);
	local t = v * (1 - (1 - f) * s);

	i = i % 6

	if i == 0 then r, g, b = v, t, p
	elseif i == 1 then r, g, b = q, v, p
	elseif i == 2 then r, g, b = p, v, t
	elseif i == 3 then r, g, b = p, q, v
	elseif i == 4 then r, g, b = t, p, v
	elseif i == 5 then r, g, b = v, p, q
	end
	
	return {r* 255, g* 255, b* 255, (a or 1) * 255}
end

--[[
////////////////////////////////////////
]]


local NX,NY = 5,5  --width, height
local learn_rate = 0.00000001 
local jitter = learn_rate * 0.7
local randomness = 1

local tnet = nn(NX,NY,2,1,nn.func.cos,nn.func.sin,learn_rate)
--tnet:addlayer(5)
--tnet:addlayer(1)
--[[tnet:addlayer(9)
tnet:addlayer(7)
tnet:addlayer(5)
tnet:addlayer(1)]]
--tnet.net[3][1].act = nn.func.sig
--tnet.net[3][1].drv = nn.func.asig
tnet:build()
local batchsize = 5

--[[
////////////////////////////////////////
]]


local train_pairs = {
	{{0,0},{0}},
	{{1,0},{1}},
	{{0,1},{1}},
	{{1,1},{0}},
	--{{1,1},{1}},
	--{{1,0.5},{1}},
	--{{0.31,0.4},{0}},

	--{{1,1},{0,0}},
	--{{1,0},{0,1}},
	--{{0,1},{1,0}},
	--{{0,0},{1,1}},
}

local train_pairs_n = #train_pairs

local runner = 1
local err,err_t = 0,{}

local spa = false
local spl = false
local time  = love.timer.getTime

function love.update(dt)
	if love.keyboard.isDown("space") and not spa then
		spa = time()+0.3
		spl = (not spl)
	elseif love.keyboard.isDown("space") and spa and spa < time() and not spl then
		spl = true
	elseif not love.keyboard.isDown("space") and spa then
		spa = false
		--spl = false
	end

end

local text = love.graphics.print
local text2 = love.graphics.printf

local cnvs = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local cnvs2 = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local netc = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local lrp = 0

local gx,gy = ScrW()/(NX),ScrH()/(NY+1)

function love.draw()
	local mx,my = love.mouse.getPosition()

	color(1,120,255,20)
	for I = 1, 2 do
		local h = ScrH()-(ScrH()*(I/2))/3
		line(0,h,ScrW(),h)
	end

	if spl then
		local t = time()+0.01
		while t > time() do
			for k,v in pairs(nn.nets) do
				if v.rv then
					if spl then
						love.graphics.setCanvas(cnvs)
							love.graphics.clear(0,0,0,255)
							color(255,255,255,254)
							love.graphics.setBlendMode("alpha")
							love.graphics.draw(cnvs2)

						love.graphics.setCanvas()


					end
				end
			end
			--local sev = 0
			for I = 1 , batchsize do

				local err,err_t,rn = tnet:smart_train(train_pairs,randomness,jitter)

				--local rnd = math.random(-math.pi*1000,math.pi*1000)/1000
				--local pair = tnet:pairpicker(train_pairs)
				--local err,err_t = tnet:train(pair)

				--sev = sev + err
				--tnet.lr = 0 --30/(100*err)
				--tnet:pairupdate(pair,err)--last: error jitter
				for k,v in pairs(nn.nets) do
					if v.rv then
						if spl then
							love.graphics.setCanvas(cnvs)
								--color(0,0,0,10)
								--line(runner,0,runner,ScrH())
								local rp = ScrH()-(ScrH()*v.rv)/3
								if I > 1 then
									love.graphics.setBlendMode("alpha")
									color(hsv(0,0,0,0.3))
									--line(runner,lrp-2,runner,rp+2)
									color(hsv(0,0,0,0.1))
									--line(runner-1,lrp-2,runner-1,rp+2)
									love.graphics.setBlendMode("add")
									color(hsv(240-(rn/train_pairs_n)*240,0.7,1,1/batchsize))
									--color(hsv(240-v.rv*360,0.7,1,1/batchsize))
									love.graphics.rectangle( "fill", runner-1,rp-2,3,3 )
									love.graphics.rectangle( "fill", runner,rp-2,1,3 )
									love.graphics.rectangle( "fill", runner-1,rp-1,3,1 )
									color(hsv(240-(rn/train_pairs_n)*240,0.7,1,1))
									--color(hsv(240-v.rv*360,0.7,1,1))
									--line(runner,lrp,runner,rp)
									--love.graphics.points( runner,rp )
								end
								--color(hsv(v.rv*240,0.6,1,0.5))
								--line(runner-1,lrp,runner,rp)
								lrp = rp
							love.graphics.setCanvas()


						end
					end
				end
			end
			love.graphics.setBlendMode("alpha")

			love.graphics.setCanvas(cnvs2)
				love.graphics.clear(0,0,0,255)
				color(255,255,255,255)
				love.graphics.draw(cnvs)
			love.graphics.setCanvas()

			tnet:applybatch()

			runner = runner + 1
			if runner > ScrW() then runner = 1 end
		end
	end

	local px,py = 50,50
	love.graphics.setCanvas(netc)
	love.graphics.clear()
	
	for k,v in pairs(nn.nets) do
		for x,r in ipairs(v.net) do
			for y,n in ipairs(r) do
				color(hsv(n[1]*120,0.5,1,1))
				local cx,cy = px+(x-1)*gx, py+(y-1)*gy
				circ(_fill, cx,cy ,10)

				if x > 1 then
					for j,cw in ipairs(v.w[x-1][y]) do
						

						local x1,y1,x2,y2 = cx,cy,cx-gx,py+(j-1)*gy
						local d = ((x1-x2)^2+(y1-y2)^2)^0.5
						local d2 = ((x1-mx)^2+(y1-my)^2)^0.5
						local d3 = ((x2-mx)^2+(y2-my)^2)^0.5
						--local a = math.min(1,(d2/d)^3)

						if (d-d2-d3)^2 < 0.001 or d2 < 10 or d3 < 10 then
							color(hsv(cw[1]*120,0.5,1,(0.4*n[1]+0.6)))
						else
							color(hsv(cw[1]*120,0.5,1,0.1))
						end

						line(x1,y1,x2,y2)
						local tx,ty = cx * 0.3 + (cx-gx)*0.7, cy * 0.3 + (py+(j-1)*gy)*0.7
						text("w["..flr(cw[1]*1000)/1000 .."]  =  "..(flr(cw[1]*v.net[x-1][j][1]*1000)/1000).." => \n=x"..(flr(v.net[x-1][j][1]*1000)/1000).."=>",tx,ty,pi+math.atan2(ty-cy,tx-cx),0.8,0.8)
					end
				end
				local t = (flr(n[2]*1000)/1000) .. " => " ..(flr(n[1]*1000)/1000).."(err:"..(flr(n[3]*1000000)/1000000)..")\nB:"..(flr(r.b*1000)/1000)
				color(0,0,0,240)
				text(t,cx-9,cy-9,-0.15,0.77,0.77,4)
				color(hsv(n[1]*120+180,0.5,1,1))
				text(t,cx-10,cy-10,-0.15,0.77,0.77,4)
			end
		end

		if v.rv then
			color(0,0,255,255)
			text(v.rv,10,10)

			for ie,e in ipairs(v.rt) do
				text((v.out[ie][1]).." / "..e,30,400+20*ie)
			end
		end
	end
	love.graphics.setCanvas()
	love.graphics.setShader(shd.ftb)
	color(255,255,255,255)
	love.graphics.draw(netc)
	love.graphics.setShader()

	color(255,255,255)
	love.graphics.setBlendMode("add")
	
	love.graphics.draw(cnvs)
	
	love.graphics.setBlendMode("alpha")

end


function love.wheelmoved(x, y) --scroll wheel stuff:
	if isDown("lshift","rshift") then
			if y > 0 then
					gx = math.min(2000000,gx*1000	*1.1) / 1000
			elseif y < 0 then
					gx = math.max(25000,gx*1000	/1.1) / 1000
			end
	elseif isDown("lctrl","rctrl") then
			if y > 0 then
					gy = math.min(2000000,gy*1000	*1.1) / 1000
			elseif y < 0 then
					gy = math.max(25000,gy*1000	/1.1) / 1000
			end
	else
		if y > 0 then
					gx = math.min(2000000,gx*1000	*1.1) / 1000
					gy = math.min(2000000,gy*1000	*1.1) / 1000
			elseif y < 0 then
					gx = math.max(25000,gx*1000	/1.1) / 1000
					gy = math.max(25000,gy*1000	/1.1) / 1000
			end
	end
end