shd = {}

shd.ftb = love.graphics.newShader([[
	//uniform number sy;
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 coladd = texture2D(texture, vec2(vTexCoord.x, vTexCoord.y));
		coladd.w = max(0,min(coladd.w,(1-vTexCoord.y)*(1-vTexCoord.y)));

		return color * coladd;
	}
]])

shd.vel = love.graphics.newShader([[

	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		//vec4 coladd = color - vec4(0.5,0.5,0,0);


		
		//color = (color + texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)))/2;

		return color;
	}
]])

shd.dff = love.graphics.newShader([[
	uniform number wc;
	uniform number ws;
	uniform number wv;
	uniform number bsx;
	uniform number bsy;
	uniform number p;
	uniform Image velmap;

	float dist = 0.0006;

	float len22(vec4 p){
		return ((p.x+p.y+p.z)/3-0.5)*2;
	}

	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		vec4 pix = texture2D(texture, vec2(vTexCoord.x, vTexCoord.y));

		float len = (1+(pix.x+pix.y+pix.z));
		len = len * len;
		
		float bsxl  = bsx * len;
		float bsyl  = bsy * len;

		float p1 = len22(texture2D(velmap, vec2(vTexCoord.x+dist, vTexCoord.y)));
		float p2 = len22(texture2D(velmap, vec2(vTexCoord.x-dist, vTexCoord.y)));
		float p3 = len22(texture2D(velmap, vec2(vTexCoord.x, vTexCoord.y+dist)));
		float p4 = len22(texture2D(velmap, vec2(vTexCoord.x, vTexCoord.y-dist)));

		float vx = p1-p2;
		float vy = p3-p4;

		//float vx = vel.x;
		//float vy = vel.y;

		float wx  = (wc * -wv) - vx/10;
		float wy  = (ws * -wv) - vy/10;

		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y + bsyl + wy))*0.0833*p;
		sum += texture2D(texture, vec2(vTexCoord.x + wx, vTexCoord.y + bsyl + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y + bsyl + wy))*0.0833*p;

		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x - bsxl + wx, vTexCoord.y - bsyl + wy))*0.0833*p;
		sum += texture2D(texture, vec2(vTexCoord.x + wx, vTexCoord.y - bsyl + wy))*0.1667*p;
		sum += texture2D(texture, vec2(vTexCoord.x + bsxl + wx, vTexCoord.y - bsyl + wy))*0.0833*p;


		return sum;
	}
]])



return shd